Bug 1075249 - 16:9 and 16:10 default resolutions not available with modesetting driver
16:9 and 16:10 default resolutions not available with modesetting driver
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: X.Org
Current
Other Other
: P3 - Medium : Normal (vote)
: ---
Assigned To: E-mail List
E-mail List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2018-01-09 20:03 UTC by Martin Wilck
Modified: 2018-06-21 21:46 UTC (History)
3 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---
sndirsch: needinfo? (tiwai)
sndirsch: needinfo? (mstaudt)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Wilck 2018-01-09 20:03:23 UTC
I recently switched from the "intel" driver to "modesetting" as generally recommended. This caused my X configuration to be broken on 2 laptops. 

Both laptops have high resolution 16:9 screens (1920x1080 and 2560x1440, respectively) which is nice when used standalone but doesn't work well in combination with large monitors (with much smaller PPI) on the desk. I've experimented with xrandr's scaling options in the past, with mixed results (blurry, a bit unstable, and not supported by graphical xrandr UIs).

Simply using a smaller resolution with the same aspect ratio on the laptop display yields better results by far. With the intel driver, these modes were offered automatically. The modesetting driver (and other drivers) only provide 4:3 default modes.

Similar reports exist already. A proposed patch that imitated the logic from the "intel" driver in the "modesetting" driver has been rejected.

https://lists.x.org/archives/xorg-devel/2016-February/048866.html
https://bugs.freedesktop.org/show_bug.cgi?id=37858
https://bugzilla.redhat.com/show_bug.cgi?id=1339930

It has been proposed to extend Xorg's "extramodes" list instead. I've created a patch that does this. See https://bugs.freedesktop.org/attachment.cgi?id=136636.

Test packages available on OBS: 
https://download.opensuse.org/repositories/home:/mwilck:/branches:/X11:/XOrg/
Comment 2 Martin Wilck 2018-01-16 10:19:19 UTC
No reaction upstream ... would it make sense to submit this in OBS nonetheless?
Comment 3 Stefan Dirsch 2018-01-16 11:45:43 UTC
Valid question. ;-)

I currently have no strong opinion on this. The only Contra I can think about is:

a) it's not upstream, apparently never will (lame, I know)
b) a lot of available modes may confuse some customers

Anybody with a stronger opinion on this? Other Contras? Max, Takashi, Michal?
Comment 4 Michal Srb 2018-01-16 13:25:46 UTC
I am in favor of taking it to OBS even before it gets upstream. Since some other drivers (notably the intel one) also add smaller 16:9 and 16:10 resolutions, users may have already seen them offered in past. The original freedesktop bug clearly states that this is the preferable solution, so I would not give up on getting it upstream. Hopefully some upstream developer will react.
Comment 5 Martin Wilck 2018-01-16 13:34:43 UTC
(In reply to Stefan Dirsch from comment #3)

> b) a lot of available modes may confuse some customers

The rather long list I added was taken from previous patches (which had taken a different approach and been rejected). Many of the low-res modes might as well be omitted, I guess. But 960x540 might be useful for some, as it's "Full HD/2".

The GNOME xrandr tool orders the modes by resolution (descending) and hints on the aspect ratio, making the selection pretty straightforward even from the long list. The low-res stuff is right at the bottom, so it doesn't irritate users.
Comment 6 Martin Wilck 2018-01-16 13:37:18 UTC
created request id 566418, feel free to reject if you change your mind :-)

Btw, I wasn't certain about the patch numbering and naming conventions you are using, so it's well possible I got it wrong.
Comment 7 Stefan Dirsch 2018-01-16 14:42:00 UTC
Accepted. Thanks, Martin!
Comment 8 Martin Wilck 2018-01-22 15:17:04 UTC
FTR, patch has been accepted upstream as well.

https://cgit.freedesktop.org/xorg/xserver/commit/hw/xfree86/common/extramodes?id=a5e9bcad7ad0887f804905b482894b85751519fb